{******************************************************************************
 * OutLook                                                                    *
 ******************************************************************************}
unit outllook;

{******************************************************************************
 * Interface                                                                  *
 ******************************************************************************}
 interface

{******************************************************************************
 * Uses                                                                       *
 ******************************************************************************}
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

{******************************************************************************
 * Costanti                                                                   *
 ******************************************************************************}
 const SPESSORE_LINEA = 4;
{******************************************************************************
 * Type                                                                       *
 ******************************************************************************}
 type
  PListaPagina = ^ListaPagina;
  PDisposizione = (Verticale,Orizzontale,Nessuna);
  TProcedureChangePage = Procedure (Sender: TObject;Pagina:integer) of object;
  TProcedureResizePage = Procedure (Sender: TObject;larg1,largh2:integer) of object;
  ListaPagina = record
    Sh    : TImage;
    Next  : PListaPagina;
    num   : Integer;       // Numero pagina;
  end;
  TOutBox = class(TPanel)
  private
    Scr1           : TScrollBox;
    Linea          : Tpanel;
    PosizioneLinea : Integer;
    Fl_Drag        : Boolean;
    Elenco         : PListaPagina;

    Bordo          : TShape;
//    Obj          : TComponent;
    PaginaAttiva   : integer;
    NumeroPagine   : integer;
    ProceduraCambioPag : TProcedureChangePage;
    ProceduraResizePag : TProcedureResizePage;
    LARGHEZZA_PAG :integer;
    ALTEZZA_PAG   :integer;
    FDisp         : PDisposizione;
    in_paint      : Boolean; (* True: Sta ridisegnando il form *)
                             (* False: Non sta ridisegnando    *)

    { Private declarations }
  protected
    { Protected declarations }
    Procedure Libera(p:PListaPagina);
    Procedure Paint; override;
    procedure set_page(num:integer);
    procedure LineaMousedown(Sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    procedure LineaMouseUp(Sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    procedure LineaMouseMove(Sender: TObject; Shift: TShiftState; X,
                           Y: Integer);
    procedure ShapeMouseDown(Sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    procedure set_altezza_pag(num:integer);
    procedure set_larghezza_pag(num:integer);
    procedure set_disp(d:PDisposizione);
    procedure PaintVerticale;
    procedure PaintOrizzontale;
    procedure set_Sx(x:integer);

  public
    Scr2  : TScrollBox;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    Procedure AddPagina(pic:TPicture);
    Procedure RemovePagina(num:integer);

    { Public declarations }
  published
    { Published declarations }
    property OnChangePage : TProcedureChangePage read ProceduraCambioPag write ProceduraCambioPag;
    property OnResize : TProcedureResizePage read ProceduraResizePag Write ProceduraResizePag;
    property CurrentPage : integer read PaginaAttiva write set_page;
    property PaginaLarghezza : integer read LARGHEZZA_PAG write set_larghezza_pag default 66;
    property PaginaAltezza: integer read ALTEZZA_PAG write set_altezza_pag default 92;
    property Disposizione : PDisposizione read FDisp write set_disp;
    property Dimensione_Sx : Integer read PosizioneLinea write set_sx;



  end;

procedure Register;

{******************************************************************************
 * Implementation                                                             *
 ******************************************************************************}
 implementation


{******************************************************************************
 * Costruttore                                                                *
 ******************************************************************************}
constructor TOutBox.Create(AOwner: TComponent);
begin
 Inherited;
// obj:=AOwner;
 PosizioneLinea    := 100;
 ctl3d             := False;
 borderstyle       := bsNone;
 Align             := alClient;
 ParentColor       := True;
 Elenco            := Nil;
 Fl_Drag           := False;
 CurrentPage       := -1;
 NumeroPagine      := 0;
 PaginaLarghezza   := 66;
 PaginaAltezza     := 93;

 scr1              := TScrollBox.Create(Self);
 scr1.BorderStyle  := bsNone;
 scr1.ctl3d        := false;
 scr1.parent       := Self;
 scr1.align        := alLeft;
 scr1.visible      := true;
 scr1.Color        := clAppWorkSpace;

 scr2              := TScrollBox.Create(Self);
 scr2.BorderStyle  := bsNone;
 scr2.ctl3d        := False;
 scr2.parent       := Self;
 scr2.align        := alRight;
 scr2.visible      := true;
 scr2.Color        := clAppWorkSpace;


 Bordo              := TShape.Create(Self);
 Bordo.parent       := scr1;
 Bordo.Pen.Color    := clRed;
 Bordo.left         := -2;
 Bordo.top          := -2;
 Bordo.Width        := 0;
 Bordo.Height       := 0;

 Bordo.Visible      := False;


 Linea             := TPanel.Create(Self);
 Linea.OnMouseDown := LineaMousedown;
 Linea.OnMouseUp   := LineaMouseUp;
 Linea.OnMouseMove := LineaMouseMove;
 Linea.Parent      := Self;
 Linea.caption     := '';
 Linea.visible     := true;

 Disposizione      := Verticale;

 OnChangePage      := Nil;
 OnResize          := Nil;

 in_paint          := False;
end;


{******************************************************************************
 * Distruttore                                                                *
 ******************************************************************************}
 destructor TOutBox.Destroy;
var App1,App2 : PListaPagina;
Begin
 App1 := Elenco;
 if(App1<>nil) then
 begin
   while(App1<>nil) do
   Begin
     app2:=app1^.Next;
     libera(app1);
     app1:=app2;
   end;
 end;
 scr1.Free;
 scr2.Free;
 Linea.Free;
 Inherited;
End;
{******************************************************************************
 * PaintVerticale                                                             *
 ******************************************************************************}
procedure TOutBox.PaintVerticale;
Var App1 : PListaPagina;
    x,y  : integer;        // Posizione del disegno
    num  : integer;        // numero disegni per riga inseriti

Begin
   scr1.width   := PosizioneLinea-1;
   scr2.width   := width - PosizioneLinea - 1;
   Linea.width  := SPESSORE_LINEA;
   Linea.Height := Height;
   Linea.top    := 0;
   Linea.Left   := PosizioneLinea;
//   Linea.Cursor := crSizeWE;

   num          := 0;
   x            := 10;
   y            := 10-Scr1.VertScrollBar.Position;
   app1 := Elenco;
   While (app1<>nil) do
   begin
     if ( x + PaginaLarghezza < scr1.ClientWidth)or(num=0) Then //Flag:=true
     else
     begin
       x      := 10;
       y      := y + PaginaAltezza + 10;
       num    := 0;
     end;
     Num  := Num + 1;
     app1^.Sh.Left := x;
     app1^.Sh.Top  := y;
     x := x + PaginaLarghezza + 10;
     //else y := y + PaginaAltezza + 10;
     App1:=App1^.Next;
   end;
end;
{******************************************************************************
 * PaintOrizzontale                                                           *
 ******************************************************************************}
procedure TOutBox.PaintOrizzontale;
Var App1 : PListaPagina;
    x,y  : integer;        // Posizione del disegno
Begin
   scr1.height  := PosizioneLinea-1;
   scr2.height  := height - PosizioneLinea - 1;
   Linea.height := SPESSORE_LINEA;
   Linea.Width  := Width;
   Linea.Left   := 0;
   Linea.Top    := PosizioneLinea;
//   Linea.Cursor := crSizeNS;
   x            := 10-Scr1.HorzScrollBar.Position;
   y            := 10;
   app1 := Elenco;
   While (app1<>nil) do
   begin
//     x      := 10;
//     y      := y + PaginaLarghezza + 10;

     app1^.Sh.Left := x;
     app1^.Sh.Top  := y;
     x := x + PaginaLarghezza + 10;
     App1:=App1^.Next;
   end;
end;

{******************************************************************************
 * Paint                                                                      *
 ******************************************************************************}
Procedure ToutBox.paint;
Begin
 Inherited;
 in_paint := True;
 if (not fl_drag) then
 begin
   if(Disposizione=verticale) then paintverticale
   else if(Disposizione=orizzontale) then PaintOrizzontale;
   CurrentPage:=CurrentPage;
 end;
 in_paint := False;

end;

{******************************************************************************
 * LineaMousedown                                                             *
 ******************************************************************************}
procedure TOutBox.LineaMousedown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
begin
 fl_drag:=true;
end;
{******************************************************************************
 * LineaMouseUp                                                               *
 ******************************************************************************}
procedure TOutBox.LineaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
Begin
 fl_drag:=false;
 x:=x+Linea.left;
 y:=y+linea.top;
 if(disposizione=verticale) then dimensione_sx := x;
 if(disposizione=orizzontale) then dimensione_sx := y;
End;
{******************************************************************************
 * LineaMouseMove                                                             *
 ******************************************************************************}
procedure TOutBox.LineaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
Begin
 if (fl_drag) then
 begin
   if(Disposizione=verticale) then
   begin
     x:=x+Linea.left;
     PosizioneLinea:=x;
     Linea.left:=x;
   end
   else
   begin
     y:=y+Linea.top;
     PosizioneLinea:=y;
     Linea.top:=y;
   end
 end;
End;

{******************************************************************************
 * ShapeMouseDown                                                             *
 ******************************************************************************}
procedure TOutBox.ShapeMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var app : PListaPagina;
begin
 app := elenco;
 while(app<>nil) do
 begin
  if((app^.sh.left=TImage(Sender).left)and(app^.sh.top=TImage(Sender).top)) then
  begin
    CurrentPage:=app^.num;
  end;
  app:=app^.Next;
 end;
end;
{******************************************************************************
 * AddPagina                                                                  *
 ******************************************************************************}
Procedure TOutBox.AddPagina(pic:TPicture);
var App1,App2 : PListaPagina;
Begin
 App1 := Elenco;
 if(App1<>nil) then
 begin
   while(App1.Next<>nil) do App1:=App1.Next;
 end;
 New(app2);
 inc(NumeroPagine);
 app2^.sh             := TImage.Create(Self);
 app2^.sh.Parent      := scr1;
 app2^.sh.Height      := PaginaAltezza;
 app2^.sh.Width       := PaginaLarghezza;
 app2^.sh.OnMouseDown := ShapeMouseDown;
 app2^.sh.Picture     := pic;
 app2^.num            := NumeroPagine;
 app2^.Next           := Nil;
 if(elenco=nil) then elenco:=app2
 else app1^.Next := app2;
 if(numeropagine=1) then CurrentPage:=1;
 Invalidate;
End;
{******************************************************************************
 * RemovePagina                                                               *
 ******************************************************************************}
Procedure TOutBox.RemovePagina(num:integer);
var App1,successivo : PListaPagina;
    Tolto           : Boolean;  {* True: Pagina eliminata *}
                                {* False: Pagina non elminata *}
Begin
 Tolto := False;
 if(numeroPagine=0) then
 begin
   exit;
 end;
 if(elenco^.num=num) then
 begin
   app1:=elenco;
   elenco:=Elenco^.Next;
   dec(NumeroPagine);
   tolto:=true;
   Libera(app1);
 end
 else
 begin
   app1:=Elenco;
   while (app1^.Next <> nil) do
   begin
     successivo:=app1^.Next;
     if(successivo^.num=num) then
     begin
       app1^.Next:=successivo^.Next;
       libera(successivo);
       dec(NumeroPagine);
       Tolto := True;
     end;
     app1:=app1^.next;
     if(app1=nil) then break;
   end;
 end;
 if (Tolto) Then
 begin
   app1:=Elenco;  // Rinumera
   while(app1<>nil) do
   begin
     if(app1^.num>=num) then dec(app1^.num);
     app1:=app1^.next;
   end;
   CurrentPage:=NumeroPagine;
   Invalidate;
 end;
End;
{******************************************************************************
 * Libera                                                                     *
 ******************************************************************************}
Procedure TOutBox.Libera(p:PListaPagina);
Begin
   p^.sh.Free;
   dispose(p);
end;


{******************************************************************************
 * set_page                                                                   *
 ******************************************************************************}
procedure TOutBox.set_page(num:integer);
var app1 : PListaPagina;
begin
 app1:=elenco;
 PaginaAttiva:=num;
 if(Disposizione=Nessuna) then
 begin
   bordo.visible:=false;
   if assigned(OnChangePage) and (not in_paint) then OnChangePage(Self,CurrentPage);
   exit;
 end
 else
 while(app1<>nil) do
 begin
   if (app1^.num=num) then
   begin
     Bordo.Left:=app1^.sh.left-2;
     Bordo.top:=app1^.sh.top-2;
     Bordo.width:=app1^.sh.width+4;
     Bordo.height:=app1^.sh.height+4;
     Bordo.visible:=true;
     if assigned(OnChangePage) then OnChangePage(Self,CurrentPage);
     exit;
   end;
   app1:=app1^.Next;
 end;
end;

{******************************************************************************
 * set_larghezza_pag                                                          *
 ******************************************************************************}
procedure TOutBox.set_larghezza_pag(num:integer);
begin
  if(num<1) then num := 3;
  LARGHEZZA_PAG:=num;
  invalidate;
end;
{******************************************************************************
 * set_altezza_pag                                                            *
 ******************************************************************************}
procedure TOutBox.set_altezza_pag(num:integer);
begin
  if(num<1) then num := 3;
  ALTEZZA_PAG:=num;
  invalidate;
end;

{******************************************************************************
 * set_disp                                                                   *
 ******************************************************************************}
procedure TOutBox.set_disp(d:PDisposizione);
begin
  FDisp:=d;
  if(Disposizione=verticale) then
  begin
    scr1.visible      := true;
    scr2.visible      := true;
    linea.visible     := true;
    linea.cursor      := CrHSplit;
    scr1.align        := alLeft;
    scr2.align        := alRight;
  end
  else if (d=orizzontale) then
  begin
    scr1.visible      := true;
    scr2.visible      := true;
    linea.visible     := true;
    linea.cursor      := CrVSplit;
    scr1.align        := alTop;
    scr2.align        := alBottom;
  end
  else
  begin
    scr1.visible      := false;
    linea.visible     := false;
    scr2.visible      := true;
    scr2.align        := alClient;
  end;
  invalidate;
  if(Assigned(OnResize)) then OnResize(Self,scr1.width,scr2.width);
end;

{******************************************************************************
 * Register                                                                   *
 ******************************************************************************}
 procedure TOutBox.set_Sx(x:integer);
 begin
  PosizioneLinea:=x;
  if(disposizione=verticale) then
  begin
    Linea.Left:=x;
    scr1.width:=x-2;
    scr2.width:=(Width-x-2-2);
  end
  else
  begin
    Linea.top:=x;
    scr1.height:=x-2;
    scr2.height:=(Height-x-2-2);

  end;
  invalidate;
  if(Assigned(OnResize)) then OnResize(Self,scr1.width,scr2.width);
 end;

{******************************************************************************
 * Register                                                                   *
 ******************************************************************************}
procedure Register;
begin
  RegisterComponents('Samples', [TOutBox]);
end;


end.
